Wie löst man Ausnahmen in Java aus?

In Java, werfen ein Ausnahme ist ein Standardmechanismus, um die abnormale Beendigung des Programms aufgrund unerwarteter Fehler zu verhindern. Dafür ist das „werfen”-Anweisung verwendet und ein Objekt der angegebenen Exception-Klasse erstellt. Sie können im Konstruktor eine beliebige Nachricht angeben, wie in der folgenden Syntax gezeigt:

throw new ExceptionClass ("Exception Message");

Erfahren Sie mehr: Tutorial zu Java-Ausnahmen

Dieser Artikel bietet eine praktische Demonstration des Auslösens einer Ausnahme in Java.

Wie löst man Java-Ausnahmen aus?

Im gegebenen Beispiel behandelt der Try-Catch-Block die möglicherweise auftretenden Ausnahmen und unterbricht den normalen Codefluss. Der werfen Die Anweisung zeigt die benutzerdefinierte Meldung für die angegebene Ausnahme an.

Innerhalb des Try-Blocks wird die Ausnahme mit der benutzerdefinierten Nachricht ausgelöst. Die „neu„Schlüsselwort erstellt ein neues“Ausnahme”, das die angegebene benutzerdefinierte Nachricht anzeigt. Innerhalb des Catch-Blocks wird die ausgelöste Ausnahme vom „“ abgefangen und gedruckt.e” Instanz der Exception-Klasse:

try
  {
throw new Exception("Basic Usage of Exception");
  }
catch(Exception e )
{
System.out.println(e);
}

Vollständiger Code und Ausgabe

Beispiel 1: Wie löst man eine geprüfte Ausnahme in Java aus?

Der Geprüfte Ausnahmen werden vom Compiler zum Zeitpunkt der Kompilierung bestimmt. Im folgenden Code verarbeitet der Java-Compiler die geprüften Ausnahmen und löst sie aus.

Die folgenden Importanweisungen enthalten die erforderlichen Abhängigkeiten und Klassen von java.util Und java.io Pakete:

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

In diesem Codeausschnitt ist die Dateiklasse Objekt „myObj„wird im Konstruktor mit dem Pfad der Datei erstellt und initialisiert. Ersetzen Sie den Platzhalter „” mit dem Pfad der Datei, die gelesen werden soll. Der Scanner Objekt „meinReader” wird mit dem Objekt der Datei zum Lesen initialisiert. Der if-Anweisung wird nur ausgeführt, wenn die Länge der Datei 0 ist und die Ausnahme ausgelöst wird. Der werfen Aussage wirft ein neues „FileNotFoundException” mit der im Code unten gezeigten, für Menschen lesbaren Fehlermeldung. Der Catch-Block fängt die ausgelöste Ausnahme ab und gibt sie aus:

try {
    File myObj = new File(<FilePath>);
    Scanner myReader = new Scanner(myObj);
    if(myObj.length() == 0)
    {
throw new FileNotFoundException("File cannot be read");
    }
} catch (FileNotFoundException e) {
    System.out.println(e);
}

Notiz: Der angegebene Dateipfad muss doppelte Schrägstriche enthalten, da der einzelne Schrägstrich in Java für Sonderzeichen verwendet wird, z. B. „C:\\Benutzer\\Dateiname“.

Vollständiger Code und Ausgabe

Beispiel 2: Wie löst man in Java eine ungeprüfte Ausnahme aus?

Ungeprüfte Ausnahmen sind die Ausnahmen, die auftreten, wenn das Programm ausgeführt wird. Solche Ausnahmen sind in der Regel nicht behebbar und beziehen sich häufig auf Systemfehler. Die ungeprüften Ausnahmen werden mit dem Schlüsselwort throw ausgelöst, wie im folgenden Beispiel gezeigt:

Innerhalb des try-Blocks werden zwei Ganzzahlvariablen initialisiert. Der if-Anweisung bestimmt die Nenner Wert. Die if-Anweisung löst eine aus Arithmetische Ausnahme mit einer individuellen Nachricht. Der else-Block dividiert den Zähler durch den Nenner, wenn die if-Anweisung falsch ist. Der Fangblock fängt die Arithmetische Ausnahme ab, löst sie aus und zeigt die Meldung auf der Konsole an:

try
{
  int numerator =10 , denominator =0;  //integer variables
  if(denominator == 0)
  {
    throw new ArithmeticException ("An exception occurred"); //throws an exception
  }
  else
  {
System.out.println(numerator/denominator);
  }
}
catch(ArithmeticException e)
{
System.out.println(e);
}

Vollständiger Code und Ausgabe

Beispiel 3: Wie löst man eine Java-Ausnahme im Methodenheader aus?

Der wirft Schlüsselwort kann mehrere Ausnahmen deklarieren. Die Ausnahme „Throws“ verwendet mehrere Catch-Blöcke und zeigt die Ausnahme an, die mit dem entsprechenden Try-Catch-Block übereinstimmt.

Syntax

Die Syntax ist wie folgt angegeben:

public static void main(String() args) throws Excep1, Excep2, ... {    //program logic }

Unterschied zwischen Werfen und Würfen

Die Begriffe „werfen“ Und „wirft„werden oft als gleich wahrgenommen. Die folgende Tabelle zeigt jedoch den Unterschied zwischen den beiden:

Werfen Würfe
Der throw-Anweisung wird innerhalb des Methodenkörpers verwendet.Der wirft Schlüsselwort wird im Nachrichtenkopf verwendet.
Die throw-Anweisung löst nur eine Ausnahme aus.Es löst mehrere und unterschiedliche Ausnahmen aus.
In ihrer Syntax verwendet die throw-Anweisung eine Instanz/ein Objekt zum Auslösen einer Ausnahme.Das Schlüsselwort throws verwendet die Klasse, um Ausnahmen in Java auszulösen.

In diesem Beispiel, mehrere Fangblöcke werden verwendet, um Ausnahmen auszulösen. Es werden nur diese Ausnahmen gelten geworfen die zu den relevanten Catch-Blöcken passen. Im Inneren Versuchen Sie es mit Blockieren, durchläuft die for-Schleife die Elemente des deklarierten Arrays. In unserem Fall löst der try-Block eine arithmetische Ausnahme aus, da kein numerischer Wert vorhanden sein kann geteilt durch 0. Der Catch-Block enthält verschiedene Ausnahmen wie z ArrayIndexOutOfBoundsException Und ArithmeticException:

int ( ) numArray= {5,4,5,6,7};
try {
  for(int i=0; i<numArray.length;i++)
  {
System.out.println(numArray(i)/0);
    }
}
catch(ArrayIndexOutOfBoundsException e)
{
  throw new ArrayIndexOutOfBoundsException("Index Out of Bound Exception");
}
catch(ArithmeticException e){
    throw new ArithmeticException("Arithmetic Exception has occurred");
}

Vollständiger Code und Ausgabe

Dies fasst die Implementierung des Auslösens von Ausnahmen in Java zusammen.

AbschlussZu werfen eine Java-Ausnahme, verwenden Sie das „werfen”-Anweisung zum Erstellen einer neuen Ausnahme mit einer benutzerdefinierten Nachricht. Die ausgelöste Ausnahme wird vom entsprechenden Catch-Block abgefangen. Der throw-Anweisung wird verwendet, um eine einzelne Ausnahme mit einer für Menschen lesbaren Beschreibung des aufgetretenen Fehlers zu deklarieren. Andererseits ist die wirft Schlüsselwort deklariert mehrere Ausnahmen. Der throw-Anweisung optimiert die Codeleistung. Beachten Sie jedoch, dass die übermäßige Verwendung dieser Aussage nicht erwünscht ist. In diesem Artikel werden verschiedene Ausnahmen beschrieben, die mit der throw-Anweisung ausgelöst werden.

Kommentar verfassen

Deine E-Mail-Adresse wird nicht veröffentlicht. Erforderliche Felder sind mit * markiert

Nach oben scrollen